| GL Studio C++ Runtime API

Public Member Functions | List of all members
DistiAttributeNeverWrite< T > Class Template Reference

`#include <gls_metadata_attributes.h>`

Inheritance diagram for DistiAttributeNeverWrite< T >:

## Public Member Functions
| DistiAttributeNeverWrite (CallbackMethodCallerBase *callback, const AttributeName &name, T *attribPtr)
| DistiAttributeNeverWrite (CallbackMethodCallerBase *callback, const AttributeName &name, const T &initialValue)
virtual bool | OkToWrite () const override
Public Member Functions inherited from DistiAttribute< T >
| DistiAttribute (CallbackMethodCallerBase *callback, const AttributeName &name, T *attribPtr)
| DistiAttribute (CallbackMethodCallerBase *callback, const AttributeName &name, const T &initialValue)
bool | Copyable () const override
long | ValueInt () override
void | ValueInt (long val) override
double | ValueFloat () override
void | ValueFloat (double val) override
DistiAttributeBase & | operator= (const DistiAttributeBase &oldClass) override
std::ostream & | WriteValue (std::ostream &outstr) override
std::istream & | ReadValue (std::istream &instr) override
std::string | Type () const override
virtual T | Value ()
virtual void | Value (const T &val)
bool | operator== (const DistiAttributeBase &rArg) override
| ~DistiAttribute () override
Public Member Functions inherited from DistiAttributeBase
| DistiAttributeBase (CallbackMethodCallerBase *callback, const AttributeName &name, bool localStorage)
virtual DistiAttributeBase & | operator= (const DistiAttributeBase &oldClass)
const AttributeName & | Name () const
AttributeName & | Name ()
bool | LocalStorage () const
virtual bool | Copyable () const
virtual bool | OkToWrite () const
virtual bool | ValueChanged ()
virtual void | ResetValueChanged ()
virtual std::string | ValueString ()
virtual void | ValueString (const std::string &s)
virtual long | ValueInt ()
virtual void | ValueInt (long val)
virtual double | ValueFloat ()
virtual void | ValueFloat (double val)
virtual void | CallCallback ()
| Calls callback CallType3 if it has been set.
virtual std::ostream & | WriteValue (std::ostream &outstr)=0
virtual std::istream & | ReadValue (std::istream &instr)=0
virtual std::string | Type () const
virtual bool | operator== (const DistiAttributeBase &r)
template<class valType >
DistiAttributeBase & | operator<< (const valType &val)
template<class valType >
DistiAttributeBase & | operator>> (valType &val)
virtual CallbackID | RegisterObserver (AttributeObserver *observer)
virtual void | UnregisterObserver (CallbackID id)
virtual void | NotifyObservers ()
Public Member Functions inherited from WeakReferenceableMixin
void | AddWeakReference (WeakReference *weakRef) override
void | NotifyWeakReferenceDestroyed (WeakReference *ref) override
virtual void | AddWeakReference (WeakReference *weakRef)=0
virtual void | NotifyWeakReferenceDestroyed (WeakReference *weakReference)=0

## Additional Inherited Members
Public Types inherited from DistiAttributeBase
typedef unsigned int | CallbackID
| Type for unique identifiers.
Protected Member Functions inherited from WeakReferenceableMixin
| WeakReferenceableMixin ()
virtual | ~WeakReferenceableMixin ()
Protected Attributes inherited from DistiAttribute< T >
T * | _attribPtr
int | _precision
Protected Attributes inherited from DistiAttributeBase
AttributeName | _name
CallbackMethodCallerBase * | _callback
ScopedPtr< DistiAttributeObserverList > | _observerList
bool | _localStorage
Protected Attributes inherited from WeakReferenceableMixin
DynamicArray< WeakReference * > * | _weakRefs

## Detailed Description

template<class T>
class disti::DistiAttributeNeverWrite< T >

Allows for the normal template to be used to load a value but never write it out This is used for compatability mostly.

## Constructor & Destructor Documentation

## ◆ DistiAttributeNeverWrite() [1/2]

DistiAttributeNeverWrite | ( | CallbackMethodCallerBase * | callback,
|  | const AttributeName & | name,
|  | T * | attribPtr
| ) |  |
| inline

Constructor, uses existing storage.

Parameters

  callback | The callback function pointer to call back.
  name | The name of this new attribute.
  attribPtr | A pointer to a pointer to existing storage for this attribute.

## ◆ DistiAttributeNeverWrite() [2/2]

DistiAttributeNeverWrite | ( | CallbackMethodCallerBase * | callback,
|  | const AttributeName & | name,
|  | const T & | initialValue
| ) |  |
| inline

Constructor, creates local storage.

Parameters

  callback | The callback function pointer to call back.
  name | The name of this new attribute.
  initialValue | The initial value of the attribute.

## Member Function Documentation

## ◆ OkToWrite()

virtual bool OkToWrite | ( |  | ) | const
| inline override virtual

This SHOULD be overriden by any derived objects that may not be ready to write at any point. The reason for this is the data is often written "NAME: VALUE". If Value is not available, we don't want to write "NAME: " first, so before writing "NAME: ", OkToWrite() can be called to see if it will have a valid value.

Returns
  True if this object is ready to have its WriteValue() called.

Reimplemented from DistiAttributeBase.

The documentation for this class was generated from the following file:

- gls_metadata_attributes.h